"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const childProcess = __importStar(require("child_process"));
const path = __importStar(require("path"));
const fs = require('fs-extra');
const ora = require('ora');
const spinner = ora();
function startKernel(shell_port, iopub_port) {
    try {
        const venvDir = fs.pathExistsSync(path.join(process.cwd(), 'pipcook_venv', 'bin', 'activate'));
        if (!venvDir) {
            fs.removeSync(path.join(process.cwd(), 'pipcook_venv'));
        }
        const output = childProcess.spawn(`${venvDir ? '' : 'pip install virtualenv && virtualenv --no-site-packages pipcook_venv && \\'} 
      source ${path.join(process.cwd(), 'pipcook_venv', 'bin', 'activate')} && pip install ipykernel==5.1.3`, [], {
            shell: true,
            cwd: process.cwd(),
        });
        output.stdout.on('data', (data) => {
            console.log(`stdout: ${data}`);
        });
        output.stderr.on('data', (data) => {
            console.error(`stderr: ${data}`);
        });
        output.on('close', (code) => {
            if (code !== 0) {
                return;
            }
            const child = childProcess.spawn(`source ${path.join(process.cwd(), 'pipcook_venv', 'bin', 'activate')} \\
      && ipython kernel --IPKernelApp.shell_port=${shell_port} --IPKernelApp.iopub_port=${iopub_port} --IPKernelApp.ip=127.0.0.1 --IPKernelApp.transport=tcp`, [], {
                shell: true,
                cwd: process.cwd(),
            });
            child.stdout.on('data', (data) => {
                if (data.includes('To connect another client to this kernel')) {
                    console.log(`stdout2: ${data}`);
                }
            });
            child.stderr.on('data', (data) => {
                console.error(`stderr2: ${data}`);
            });
        });
    }
    catch (err) {
        console.error(err);
    }
    childProcess;
}
exports.startKernel = startKernel;
//# sourceMappingURL=connectkernel.js.map