import { PythonObject } from '../types/python-object';
export default class Python {
    scope: string;
    statements: string[];
    static pythons: Python[];
    static constructPythonStatements(python: Python): Promise<void>;
    static scope(scope: string, callback: Function): Promise<void>;
    nA: (arg: any) => any;
    import: (packageName: string) => PythonObject;
    fromImport(packageName: string, importNames: string[]): PythonObject[];
    createNumber: (number: number) => PythonObject;
    createString: (string: string) => PythonObject;
    createBoolean: (value: boolean) => PythonObject;
    createNone: () => PythonObject;
    createTuple: (value: any[]) => PythonObject;
    createList: (value: any[]) => PythonObject;
    createSet: (value: any[]) => PythonObject;
    createDictionary: (value: any) => PythonObject;
    print: (object: PythonObject) => void;
    math: {
        add: (object1: PythonObject, object2: PythonObject) => PythonObject;
        minus: (object1: PythonObject, object2: PythonObject) => PythonObject;
        multiply: (object1: PythonObject, object2: PythonObject) => PythonObject;
        divide: (object1: PythonObject, object2: PythonObject) => PythonObject;
        mod: (object1: PythonObject, object2: PythonObject) => PythonObject;
        pow: (object1: PythonObject, object2: PythonObject) => PythonObject;
        floorDivide: (object1: PythonObject, object2: PythonObject) => PythonObject;
    };
}
